VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "The Source"
   ClientHeight    =   3150
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6135
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3150
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer timMouse 
      Interval        =   200
      Left            =   5160
      Top             =   4800
   End
   Begin VB.Frame fra 
      Caption         =   "Mouse Capture Test"
      Height          =   1575
      Index           =   1
      Left            =   2880
      TabIndex        =   9
      Top             =   600
      Width           =   3135
      Begin VB.PictureBox picButton 
         BorderStyle     =   0  'None
         Height          =   735
         Left            =   1920
         ScaleHeight     =   735
         ScaleWidth      =   975
         TabIndex        =   4
         TabStop         =   0   'False
         Top             =   480
         Width           =   975
         Begin VB.Line lnBottom 
            BorderColor     =   &H80000010&
            Visible         =   0   'False
            X1              =   0
            X2              =   975
            Y1              =   720
            Y2              =   720
         End
         Begin VB.Line lnRight 
            BorderColor     =   &H80000010&
            Visible         =   0   'False
            X1              =   960
            X2              =   960
            Y1              =   0
            Y2              =   720
         End
         Begin VB.Line lnLeft 
            BorderColor     =   &H80000014&
            Visible         =   0   'False
            X1              =   0
            X2              =   0
            Y1              =   0
            Y2              =   720
         End
         Begin VB.Line lnTop 
            BorderColor     =   &H80000014&
            Visible         =   0   'False
            X1              =   0
            X2              =   960
            Y1              =   0
            Y2              =   0
         End
      End
      Begin VB.Label lblMouseDown 
         BackStyle       =   0  'Transparent
         Caption         =   "MouseDown = False"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   1080
         Width           =   1695
      End
      Begin VB.Label lblMouseOver 
         BackStyle       =   0  'Transparent
         Caption         =   "MouseOver = False"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   720
         Width           =   1695
      End
      Begin VB.Label l 
         BackStyle       =   0  'Transparent
         Caption         =   "Flags -"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   10
         Top             =   360
         Width           =   1695
      End
   End
   Begin VB.Frame fra 
      Caption         =   "Mouse Position"
      Height          =   1575
      Index           =   0
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   2655
      Begin VB.CommandButton cmdMouse 
         Caption         =   "&Set"
         Height          =   315
         Index           =   1
         Left            =   1320
         TabIndex        =   3
         Top             =   1080
         Width           =   975
      End
      Begin VB.CommandButton cmdMouse 
         Caption         =   "&Get"
         Height          =   315
         Index           =   0
         Left            =   240
         TabIndex        =   2
         Top             =   1080
         Width           =   975
      End
      Begin VB.TextBox txtY 
         Height          =   285
         Left            =   480
         TabIndex        =   1
         Top             =   720
         Width           =   1815
      End
      Begin VB.TextBox txtX 
         Height          =   285
         Left            =   480
         TabIndex        =   0
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label l 
         Caption         =   "Y -"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   8
         Top             =   720
         Width           =   255
      End
      Begin VB.Label l 
         Caption         =   "X -"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Top             =   360
         Width           =   255
      End
   End
   Begin VB.Label lOver 
      BackStyle       =   0  'Transparent
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   2280
      Width           =   5895
   End
   Begin VB.Label l 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   $"frmMain.frx":0442
      Height          =   495
      Index           =   4
      Left            =   120
      TabIndex        =   13
      Top             =   2640
      Width           =   5895
   End
   Begin VB.Label l 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Mouse Tutorial"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   26.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00800000&
      Height          =   495
      Index           =   0
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   6135
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim MouseDown As Boolean
Dim MouseOver As Boolean
Dim Mouse As New CMouse
Enum ButtonState
    Up = 0
    Down = 1
    Flat = 2
End Enum

Private Sub cmdMouse_Click(Index As Integer)
    If Index = 0 Then
        txtX = Mouse.X
        txtY = Mouse.Y
    Else
        Mouse.X = CLng(CDbl(txtX))
        Mouse.Y = CLng(CDbl(txtY))
    End If
End Sub

Private Sub picButton_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbLeftButton Then
        MouseDown = True
        lblMouseDown = "MouseDown = True"
        SetCapture picButton.hWnd
        SetState Down
    End If
End Sub

Private Sub picButton_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    MouseOver = (X >= 0) And (X <= picButton.Width) And (Y >= 0) And (Y <= picButton.Height)
    If MouseOver Then
        lblMouseOver = "MouseOver = True"
        If MouseDown Then
            SetState Down
        Else
            SetState Up
        End If
    Else
        lblMouseOver = "MouseOver = False"
        If MouseDown Then
            SetState Up
        Else
            ReleaseCapture
            SetState Flat
            Exit Sub
        End If
    End If
    SetCapture picButton.hWnd
End Sub

Private Sub picButton_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'MouseOver = (X >= 0) And (X <= picButton.Width) And (Y >= 0) And (Y <= picButton.Height)
    'If MouseOver And MouseDown then they clicked on the button
    ReleaseCapture
    SetState Flat
    MouseDown = False
    lblMouseDown = "MouseDown = False"
End Sub

Sub SetState(ByVal State As ButtonState)
    Dim Shadow As OLE_COLOR, Highlight As OLE_COLOR
    Select Case State
    Case Up
        Shadow = vb3DShadow
        Highlight = vb3DHighlight
    Case Down
        Shadow = vb3DHighlight
        Highlight = vb3DShadow
    End Select
    lnTop.Visible = (State <> Flat)
    lnBottom.Visible = (State <> Flat)
    lnRight.Visible = (State <> Flat)
    lnLeft.Visible = (State <> Flat)
    lnTop.BorderColor = Highlight
    lnLeft.BorderColor = Highlight
    lnRight.BorderColor = Shadow
    lnBottom.BorderColor = Shadow
End Sub

Private Sub timMouse_Timer()
    lOver = "Mouse is over " & Mouse.WindowOver(Mouse.X, Mouse.Y)
End Sub
