VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CGradient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Dim m_Canvas As Form
Dim m_Vertical As Boolean

Dim i As Integer

Dim EC(2) As Integer
Dim SC(2) As Integer

Property Get Canvas() As Form
    Set Canvas = m_Canvas
End Property

Property Set Canvas(New_Canvas As Form)
    Set m_Canvas = New_Canvas
End Property

Property Get StartColor(ByVal Index As Integer) As Integer
    StartColor = SC(Index)
End Property

Property Let StartColor(ByVal Index As Integer, ByVal New_Color As Integer)
    SC(Index) = New_Color
End Property

Property Get EndColor(ByVal Index As Integer) As Integer
    EndColor = EC(Index)
End Property

Property Let EndColor(ByVal Index As Integer, ByVal New_Color As Integer)
    EC(Index) = New_Color
End Property

Property Get Vertical() As Boolean
    Vertical = m_Vertical
End Property

Property Let Vertical(ByVal New_Vertical As Boolean)
    m_Vertical = New_Vertical
End Property

Sub DrawGradient()
    On Error GoTo ErrGradient
    Dim ScaleMode As ScaleModeConstants
    With m_Canvas
    ScaleMode = .ScaleMode
    .ScaleMode = vbPixels
    Select Case m_Vertical
    Case False
        For i = 0 To .ScaleHeight
            Canvas.Line (0, i)-(.ScaleWidth, i), RGB( _
                ((i / .ScaleHeight) * SC(0)) + ((1 - i / .ScaleHeight) * EC(0)), _
                ((i / .ScaleHeight) * SC(1)) + ((1 - i / .ScaleHeight) * EC(1)), _
                ((i / .ScaleHeight) * SC(2)) + ((1 - i / .ScaleHeight) * EC(2)))
        Next
    Case True
        For i = 0 To .ScaleWidth
            Canvas.Line (i, 0)-(i, .ScaleHeight), RGB( _
                ((i / .ScaleWidth) * SC(0)) + ((1 - i / .ScaleWidth) * EC(0)), _
                ((i / .ScaleWidth) * SC(1)) + ((1 - i / .ScaleWidth) * EC(1)), _
                ((i / .ScaleWidth) * SC(2)) + ((1 - i / .ScaleWidth) * EC(2)))
        Next
    End Select
    .ScaleMode = ScaleMode
    End With
ErrGradient:
End Sub
