VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Gradient Tutorial"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7260
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   361
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   484
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDraw 
      Caption         =   "&Draw"
      Height          =   195
      Left            =   5280
      TabIndex        =   9
      Top             =   240
      Width           =   855
   End
   Begin VB.CheckBox chkVert 
      Caption         =   "Vertical"
      Height          =   255
      Left            =   4320
      TabIndex        =   8
      Top             =   240
      Width           =   855
   End
   Begin VB.HScrollBar E 
      Height          =   135
      Index           =   2
      LargeChange     =   20
      Left            =   2520
      Max             =   255
      TabIndex        =   5
      Top             =   480
      Width           =   1695
   End
   Begin VB.HScrollBar E 
      Height          =   135
      Index           =   1
      LargeChange     =   20
      Left            =   2520
      Max             =   255
      TabIndex        =   4
      Top             =   360
      Width           =   1695
   End
   Begin VB.HScrollBar E 
      Height          =   135
      Index           =   0
      LargeChange     =   20
      Left            =   2520
      Max             =   255
      TabIndex        =   3
      Top             =   240
      Width           =   1695
   End
   Begin VB.HScrollBar S 
      Height          =   135
      Index           =   2
      LargeChange     =   20
      Left            =   0
      Max             =   255
      TabIndex        =   2
      Top             =   480
      Width           =   1695
   End
   Begin VB.HScrollBar S 
      Height          =   135
      Index           =   1
      LargeChange     =   20
      Left            =   0
      Max             =   255
      TabIndex        =   1
      Top             =   360
      Width           =   1695
   End
   Begin VB.HScrollBar S 
      Height          =   135
      Index           =   0
      LargeChange     =   20
      Left            =   0
      Max             =   255
      TabIndex        =   0
      Top             =   240
      Width           =   1695
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   $"frmMain.frx":0442
      Height          =   375
      Left            =   0
      TabIndex        =   10
      Top             =   4920
      Width           =   7215
   End
   Begin VB.Label l 
      BackStyle       =   0  'Transparent
      Caption         =   "End Color"
      Height          =   255
      Index           =   1
      Left            =   2520
      TabIndex        =   7
      Top             =   0
      Width           =   1695
   End
   Begin VB.Label l 
      BackStyle       =   0  'Transparent
      Caption         =   "Start Color"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Grad As New CGradient
Dim i As Integer

Private Sub chkVert_Click()
    Grad.Vertical = IIf(chkVert.Value = 0, True, False)
End Sub

Private Sub cmdDraw_Click()
    Grad.DrawGradient
End Sub

Private Sub E_Change(Index As Integer)
    Grad.EndColor(Index) = E(Index).Value
End Sub

Private Sub Form_Load()
    With Grad
    Set .Canvas = Me
    .EndColor(0) = 255
    .EndColor(1) = 0
    .EndColor(2) = 0
    .StartColor(0) = 0
    .StartColor(1) = 0
    .StartColor(2) = 255
    .Vertical = False
    End With
    Equalize
End Sub

Private Sub Form_Paint()
    Grad.DrawGradient
End Sub

Sub Equalize()
    For i = 0 To 2
        S(i).Value = Grad.StartColor(i)
        E(i).Value = Grad.EndColor(i)
    Next
    chkVert.Value = IIf(Grad.Vertical, 0, 1)
End Sub

Private Sub Form_Resize()
    Form_Paint
End Sub

Private Sub S_Change(Index As Integer)
    Grad.StartColor(Index) = S(Index).Value
End Sub
